//#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#define all(x) (x).begin(), (x).end()
#define die(x) { cout << (x); exit(0); }
#define files(x) freopen(#x".in", "r", stdin); \
                 freopen(#x".out", "w", stdout)

using namespace std;
typedef long long lint;
typedef pair<int, int> pii;
const lint inf = 1000*1000*1000 + 7;

struct segment {
    int l, r;
} s[100001];

int n;

inline bool intersect(int i, int j) {
    return s[i].r >= s[j].l && s[j].r >= s[i].l;
}

bool guess(int ind) {
    for (int i = 0; i < n; i++)
        if (!intersect(i, ind))
            return true;
    return false;
}

int main() {
    files(magic);
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

    int minr = inf, maxl = -inf, l, r, id1, id2;
    cin >> n;
    for (int i = 0; i < n+1; i++) {
        cin >> l >> r;
        s[i] = {l, r};
        if (r < minr) {
            minr = r;
            id1 = i;
        }
        if (l > maxl) {
            maxl = l;
            id2 = i;
        }
    }

    if (guess(id1))
        cout << id1+1;
    else
        cout << id2+1;


    return 0;
}
/*
2
1 2
2 3
4 5
*/
