/* GCC */

#include <cstdio>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

bool ComDot(int a1, int a2, int b1, int b2){
    if ((a1 <= b1) && (a2 >= b1)) return true;
    if ((a1 <= b2) && (a2 >= b2)) return true;
    return false;
}

int main(){
    freopen ("magic.in", "r", stdin);
    freopen ("magic.out", "w", stdout);

    int n;
    vector <pair <int, int> > Edge;

    scanf("%d", &n);
    Edge.resize(n+1);

    for (int i = 0; i<=n; i++){
        scanf("%d%d", &Edge[i].first, &Edge[i].second);
    }

    for (int l = 0; l<=n; l++){
        int k = 0, num = -1;
        for (int i = 0; i<=n; i++) {
            if (!ComDot(Edge[l].first, Edge[l].second, Edge[i].first, Edge[i].second)){
                k++; num = i;
            }
        }

        if (k > 0){
            if (k == 1) printf("%d", num + 1); else printf("%d", l+1);
            return 0;
        }
    }

    printf("1");


    return 0;
}
