/* GCC */
#include <iostream>
#include <fstream>
#include <cstdio>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

int main()
{
    const int milliard = 1000000000;
    ifstream in;
    ofstream out;
    //in = fopen("A.in", "r");
    in.open("magic.in");
    out.open("magic.out");
    int n;
    in >> n;
    int l = 0, r = milliard;
    int segments_l[n+1];
    int segments_r[n+1];
    int before_l[n+1];
    int before_r[n+1];
    before_l[0] = 0;
    before_r[0] = milliard;
    int after_l[n+1];
    int after_r[n+1];
    after_l[n] = 0;
    after_r[n] = milliard;

    for (int i = 0; i < n; i++) {
        int li, ri;
        in >> li >> ri;
        segments_l[i] = li;
        segments_r[i] = ri;
        if (li > l) l = li;
        if (ri < r) r = ri;
        before_l[i+1] = l;
        before_r[i+1] = r;
    }

    in >> segments_l[n] >> segments_r[n];

    l = 0;
    r = milliard;
    for (int i = n; i > 0; i--) {
        int li = segments_l[i], ri = segments_r[i];
        if (li > l) l = li;
        if (ri < r) r = ri;
        after_l[i-1] = l;
        after_r[i-1] = r;
    }

    for (int i = 0; i <= n; i++) {
        int lx, rx;
        lx = max(before_l[i], after_l[i]);
        rx = min(before_r[i], after_r[i]);
        if (lx <= rx) {
            out << i + 1 << endl;
            return 0;
        }
    }
    return 0;
}

/*int main()
{
    ifstream in;
    ofstream out;
    //in = fopen("A.in", "r");
    in.open("magic.in");
    out.open("magic.out");
    int n;
    in >> n;
    int l = 0, r = 1000000000;
    int ans = 1;
    for (int i = 0; i <= n; i++) {
        int li, ri;
        in >> li >> ri;
        if (li > l) l = li;
        if (ri < r) r = ri;
        if (r < l) {
            ans = i + 1;
            break;
        }
    }
    out << ans << endl;
    return 0;
}*/
