""" Python 3 """
lns = open("magic.in").readlines()

n = int(lns[0])
segments = []
groups = []
groupPoints = []

for x in range(1, n+1+1):
	spl = lns[x].split(" ")
	beginsAt = int(spl[0])
	endsAt = int(spl[1])
	segments.append((beginsAt, endsAt))

	groupIndex = -1
	for i in range(len(groupPoints)):
		if beginsAt in groupPoints[i] or endsAt in groupPoints[i]:
			if groupIndex != -1:
				if len(groups[i]) > len(groups[groupIndex]):
					groupIndex = i
			else:
				groupIndex = i
	if groupIndex == -1:
		groups.append([x])
		groupPoints.append([beginsAt, endsAt])
	else:
		groups[groupIndex].append(x)

smallestGroup = None
for group in groups:
	if smallestGroup is None or len(group) < len(smallestGroup):
		smallestGroup = group

output = open("magic.out", 'w')
output.write(str(smallestGroup[0]) + '\n')
output.close()