import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Arrays;
import java.util.*;

public class magic {

	public static void main(String[] args) throws Exception {
		BufferedReader reader = new BufferedReader(new FileReader("magic.in"));
		FileWriter writer = new FileWriter("magic.out");

		int total = Integer.parseInt(reader.readLine()) + 1;
		int result = 0;
		int[][] segments = new int[total][2];
		for (int i = 0; i < total; i++) {
			String[] split = reader.readLine().split(" ");
			int start = Integer.parseInt(split[0]);
			int end = Integer.parseInt(split[1]);
			segments[i][0] = start;
			segments[i][1] = end;
		}
		
		int lastFail = 0;
		int[] failCount = new int[total];
		for(int i = 0; i < total; i++) {
			int[] segment1 = segments[i];
			for (int i2 = i + 1; i2 < total; i2++) {
				int[] segment2 = segments[i2];
				if (segment1[0] > segment2[1] || segment1[1] < segment2[0]) {
					lastFail = i;
					failCount[i]++;
					if(failCount[i] > 1) {
						writer.write(Integer.toString(i + 1));
						reader.close();
						writer.close();
						return;
					}
					failCount[i2]++;
					if(failCount[i2] > 1) {
						writer.write(Integer.toString(i2 + 1));
						reader.close();
						writer.close();
						return;
					}
				}
			}
		}
		writer.write(Integer.toString(lastFail + 1));
//		System.out.println(totalFails);
		reader.close();
		writer.close();
	}
}
