/* GCC */
#include <iostream>
#include <vector>
#include <set>
//#include <iomanip>
//#include <string>
#include <cstdio>
//#include <list>
//#include <map>
//#include <algorithm>

using namespace std;

long double conectedPoint = 0;

bool isConected (pair<long double, long double>& a, pair<long double, long double>& b)
{
	if(a.first == b.first) return true;
	if(a.first == b.second) return true;
	if(a.second == b.first) return true;
	if(a.second == b.second) return true;

	return false;
}

bool threeElementsHaveOnePoint (pair<long double, long double>& a, pair<long double, long double>& b,
	                            pair<long double, long double>& c)
{
	long double arr[] = {a.first, a.second, b.first, b.second, c.first, c.second};
	multiset<long double> repet(arr, arr+6);


	for(int i = 0; i < 6; i++){
		if(repet.count(arr[i]) == 3){
			conectedPoint = arr[i];
			return true;
		}
	}

	return false;
}

int main()
{
	freopen("magic.in", "r", stdin);
	freopen("magic.out", "w", stdout);
	long int n;
	cin >> n;
	n++;


	if(n == 1){
		cout << 1 << endl;
		return 0;
	} else if(n == 2){
		cout << 1 << endl;
		return 0;
	}

	vector<pair<long double, long double> > vals(n);

	for(long int i = 0; i < n; i++){
		cin >> vals[i].first >> vals[i].second;
	}

	//сначала расмотрим случай, когда фальшивка среди первых двух
	//если они не равны
	//тогда сверяем с третим элементом, и находим ответ
	if(isConected(vals[0], vals[1])){
		if(n == 3){
			cout << 3 << endl;
			return 0;
		} else if (threeElementsHaveOnePoint(vals[0], vals[1], vals[2])){
			for(long int i = 3; i < n; i++){
				if((vals[i].first != conectedPoint) && (vals[i].second != conectedPoint)){
					cout << (i + 1) << endl;
					return 0;
				}
			}
			cout << 1 << endl;
			return 0;
		} else if (threeElementsHaveOnePoint(vals[0], vals[2], vals[3])){
			cout << 2 << endl;
			return 0;
		} else if (threeElementsHaveOnePoint(vals[1], vals[2], vals[3])){
			cout << 1 << endl;
			return 0;
		} else if (threeElementsHaveOnePoint(vals[0], vals[1], vals[3])){
			cout << 3 << endl;
			return 0;
		}
	} else{
		bool con0_2 = isConected(vals[0], vals[2]);
		bool con1_2 = isConected(vals[1], vals[2]);

		if(con0_2 && con1_2){
			if(n == 3){
				cout << "1" << endl;
				return 0;
			} else{
				if (threeElementsHaveOnePoint(vals[1], vals[2], vals[3])){
					cout << "1" << endl;
					return 0;
				} else{
					cout << "2" << endl;
					return 0;
				}
			}
		} else if(con0_2){
			cout << "2" << endl;
			return 0;
		} else{
			cout << "1" << endl;
			return 0;
		}
	}
	cout << "1" << endl;

	//если они равны, то снова же сверяем с третим, елси нужно,
	//если нужно то сверим и с четвёртым

	//если фальшивка дальше



	return 0;
}
