#include <bits/stdc++.h>
#define fr first
#define sd second
#define INF 1000000007

using namespace std;

bool touch(pair<int, int> a, pair<int, int> b){
    if (a.fr <= b.sd && a.sd >= b.fr) return true;
    else return false;
}

int main(){
    freopen("magic.in", "r", stdin);
    freopen("magic.out", "w", stdout);

    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    int n;
    cin >> n; n++;
    vector<pair<pair<int, int>, int> > vec(n);
    for(int i = 0; i < n; i++) {
        cin >> vec[i].fr.fr >> vec[i].fr.sd;
        vec[i].sd = i+1;
    }

    if (n <= 2){
        cout << "1\n";
        return 0;
    }

    sort(vec.begin(), vec.end());

    if (vec[0].fr.sd < vec[1].fr.fr){
        cout << vec[0].sd;
        return 0;
    }
    if (vec[n-2].fr.sd < vec[n-1].fr.fr){
        cout << vec[n-1].sd;
        return 0;
    }


    if (n < 10005){
        vector<int> per;

        for(int i = 0; i < n; i++){
            per.clear();

            for(int j = 0; j < n; j++)
                if (!touch(vec[i].fr, vec[j].fr))
                    per.push_back(vec[j].sd);

            if (per.size() == 1){
                cout << per[0] << "\n";
                return 0;
            }

            if (per.size() > 1){
                cout << vec[i].sd << "\n";
                return 0;
            }
        }
        cout << "1\n";
        return 0;
    }

    vector<pair<pair<int, int>, int> > LL(n), RR(n);

    LL[0] = vec[0];
    for(int i = 1; i < n; i++){
        LL[i].fr.fr = max(LL[i-1].fr.fr, vec[i].fr.fr);
        LL[i].fr.sd = min(LL[i-1].fr.sd, vec[i].fr.sd);
        LL[i].sd = vec[i].sd;
    }

    RR.back() = vec.back();
    for(int i = n-2; i > -1; i--){
        RR[i].fr.fr = max(RR[i+1].fr.fr, vec[i].fr.fr);
        RR[i].fr.sd = min(RR[i+1].fr.sd, vec[i].fr.sd);
        RR[i].sd = vec[i].sd;
    }

    for(int i = 1; i < n-1; i++)
    if (LL[i-1].fr.fr < LL[i-1].fr.sd && RR[i+1].fr.fr < RR[i+1].fr.sd && RR[i+1].fr.fr < LL[i-1].fr.sd){
        cout << vec[i].sd << "\n";
        return 0;
    }
    cout << "1\n";


    return 0;
}

/*
#include <iostream>
#include <vector>
#include <utility>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <string>

*/
