#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <stdio.h>
#include <unordered_map>
#include <set>

using namespace std;

typedef long long ll;

const int inf = 1000000007;
const int maxn = 1000010;

struct Point{
    int num;
    bool beg;
    int st;
};

int main() {
    //freopen("magic.in", "r", stdin);freopen("magic.out", "w", stdout);
    int n;
    scanf("%d", &n);
    set<int> mas;
    int f, s;
    unordered_map<int, vector<Point>> check;
    for (int i = 0; i < n+1; i++) {
        scanf("%d%d", &f, &s);
        mas.insert(f);
        mas.insert(s);
        check[f].push_back({i+1, 1, f});
        check[s].push_back({i+1, 0, f});
    }
    int curo = 0, curp = 0;
    unordered_map<int,int> noo, nop;
    for (int i : mas) {
        int m = 0;
        for (Point p : check[i])
            if (p.beg) {
                curo++;
                curp++;
            } else
                m++;
        noo[i] = curo;
        nop[i] = curp;
        curo -= m;
    }
//    for (int i : mas)
//        for (Point p : check[i])
//            cout << i << " " << p.num << " " << p.beg << " " << p.st << " noo: " << noo[i] << " nop: " << nop[i] << endl;
//    cout << endl;
    int over[n+1];
    int ans = 0;
    int best = inf;
    for (int i : mas)
        for (Point p : check[i])
            if (!p.beg) {
                over[p.num] = nop[i] - (nop[p.st] - noo[p.st])-1;
                //cout << p.num << " " << over[p.num] << endl;
                if (over[p.num] < best) {
                    ans = p.num;
                    best = over[p.num];
                }
            }
    printf("%d", ans);
    return 0;
}
/*
4
2 8
3 4
3 5
4 6
0 1
*/
