#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <stdio.h>
#include <map>
#include <unordered_map>
#include <set>

using namespace std;

typedef long long ll;

const int inf = 1000000007;
const int maxn = 1000010;

struct Point{
    int num;
    bool beg;
    int st;
};

int main() {
    freopen("magic.in", "r", stdin);freopen("magic.out", "w", stdout);
    int n;
    scanf("%d", &n);
    int f, s;
    map<int, vector<Point>> check;
    for (int i = 0; i < n+1; i++) {
        scanf("%d%d", &f, &s);
        check[f].push_back({i+1, 1, f});
        check[s].push_back({i+1, 0, f});
    }
    int curo = 0, curp = 0, m;
    unordered_map<int, int> noo, nop;
    int ans = 0, best = inf, over;
    for (pair<int, vector<Point>> c : check) {
        m = 0;
        for (Point p : c.second)
            if (p.beg) {
                curo++;
                curp++;
            } else
                m++;
        noo[c.first] = curo;
        nop[c.first] = curp;
        curo -= m;
        for (Point p : c.second)
            if (!p.beg) {
                over = nop[c.first] - (nop[p.st] - noo[p.st])-1;
                if (over < best) {
                    ans = p.num;
                    if (best != inf && best-over > 1) {
                        printf("%d", ans);
                        return 0;
                    }
                    best = over;
                }
            }
    }
    printf("%d", ans);
    return 0;
}
/*
4
2 8
3 4
3 5
4 6
0 1
*/
