/* GCC */
#include <iostream>
#include <stdio.h>

using namespace std;

#define MAXN 100100

int n;
pair<int, int> A[MAXN];

pair<int, int> cross(pair<int, int> a, pair<int, int> b)
{
    pair<int, int> res;
    if ((a.second < b.first) || (b.second < a.first)){
        res.first = -1;
        res.second = -1;
        return res;
    }
    if (a.first < b.first)
        res.first = b.first;
    else
        res.first = a.first;
    if (a.second > b.second)
        res.second = b.second;
    else
        res.second = a.second;

    return res;
}

int main(void)
{
    freopen("magic.in", "r", stdin);
    freopen("magic.out", "w", stdout);

    cin >> n; n++;
    for (int i=1; i<=n; i++){
        scanf("%d %d", &A[i].first, &A[i].second);
    }

    pair<int, int> x = A[1], y;
    int t=0;
    for (int i=2; i<=n; i++){
        y = cross(x, A[i]);
        if (y.first == -1){
            if (t != 0){
                cout << t-1 << endl;
                return 0;
            }
            t = i;
            y = x;
        }
        x = y;
    }

    if (t == 0)
        cout << "2" << endl;
    else
        cout << t << endl;
    return 0;
}
