#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

struct rect{
    int x1, x2, y1, y2;
};

void fillSpace(vector<vector<int>* > field, rect pl, int numb, int a){
    for(int x = pl.x1 - 1; x < pl.x2; x++){
        for(int y = pl.y1 - 1; y < pl.y2; y++){
            field[y * a + x]->push_back(numb);
        }
    }
}

int main()
{
    ifstream iFile;
    iFile.open("football.in");
    int a, b;
    int q;

    iFile >> a >> b >> q;

    vector<vector<int>* > field;
    for(int i = 0; i < a * b; i++){
        field.push_back(new vector<int>());
    }
    for(int i = 0; i < q; i++){
        rect pl;
        iFile >> pl.x1 >> pl.y1 >> pl.x2 >> pl.y2;
        fillSpace(field, pl, i + 1, a);
    }
    iFile.close();
    bool** fr = new bool*[q];
    for(int i =  0; i < q; i++){
        fr[i] = new bool[q];
    }
    for(int i = 0; i < q; i++){
        for(int j = 0; j < q; j++){
            fr[i][j] = false;
        }
    }
    int pares = 0;
    for(int x = 0; x < a; x++){
        for(int y = 0; y < b; y++){
            vector<int>* curVec = field[y*a+x];
            for(int i = 0; i < curVec->size(); i ++){
                for(int j = i; j < curVec->size(); j++){
                    int first = curVec->at(i);
                    int second = curVec->at(j);
                    if(first == second){
                        continue;
                    }
                    if(!fr[first][second]){
                        fr[first][second] = true;
                        pares++;
                    }
                }
            }
        }
    }


    ofstream oFile;
    oFile.open("football.out");
    oFile << pares << endl;
    oFile.close();
    return 0;
}
