/* GCC */
#include <bits/stdc++.h>

#define pb push_back
#define x first
#define y second

#define pii pair<int, int>

#define open(s) freopen(s".in", "r", stdin); freopen(s".out", "w", stdout);

typedef long long ll;

using namespace std;

struct sq {
    pii top;
    pii btm;

    bool operator < (sq sd) {
        if (this->top.x < sd.top.x)
            return true;
        else
            if (this->top.x > sd.top.x)
                return false;
            else
            {
                return this->top.y <= sd.top.y;
            }
    }
};

int main(){
    open("football");
    int n, m, q;
    ll cnt = 0;
    scanf("%d%d%d", &n, &m, &q);

    vector <sq> inp(q);

    for (int i = 0; i < q; ++i)
    {
        int x1, y1, x2, y2;
        scanf("%d%d%d%d", &x1, &y1, &x2, &y2);

        sq temp = {{x1, y1}, {x2, y2}};
        inp[i] = temp;
    }

    sort(inp.begin(), inp.end());

    for (int i = 0; i < q; ++i)
        for (int j = i + 1; j < q; ++j)
        {
            if (inp[i].btm.y >= inp[j].top.y && inp[j].top.x <= inp[i].btm.x)
                ++cnt;
        }

    printf("%d", cnt);

    return 0;
}

