/* GCC */

#include<fstream>

using namespace std;

const long long mod = 1e9+1;

long long n, c, curr[200], next[200];

void clearnext(){
    for(int i = 0; i <= c; i++){
        next[i] = 0;
    }
}

int main(){
    ifstream in;
    in.open("radioactive.in");
    ofstream out;
    out.open("radioactive.out");

    in >> n >> c;
    curr[0] = 1;
    for(long long i = 2; i <= n; i += 2){
        clearnext();
        //next[0]
        for(int i = 0; i < c; i++){
            next[0] += (curr[i] * 2) % mod;
            next[0] %= mod;
        }
        next[0] = (next[0] + curr[c]) % mod;
        //next[1]
        for(int i = 0; i <= c; i++){
            next[1] = (next[1] + curr[i]) % mod;
        }
        //next[i]
        for(int i = 2; i <= c; i++){
            next[i] = curr[i-2];
        }
        swap(curr, next);
    }
    if(n % 2 == 1){
        clearnext();
        //next[0]
        for(int i = 0; i <= c; i++){
            next[0] = (next[0] + curr[i]) % mod;
        }
        //next[i]
        for(int i = 1; i <= c; i++){
            next[i] = next[i-1];
        }
        swap(curr, next);
    }
    long long sum = 0;
    for(int i = 0; i <= c; i++){
        sum = (sum + curr[i]) % mod;
    }
    out << sum << endl;

    out.close();
    in.close();
}

