/* GCC */

#include<fstream>

using namespace std;

const long long mod = 1e9+1;

long long n, c, currarr[201], nextarr[201];

void clearnext(){
    for(int i = 0; i <= c; i++){
        nextarr[i] = 0;
    }
}

int main(){
    ifstream in;
    in.open("radioactive.in");
    ofstream out;
    out.open("radioactive.out");

    in >> n >> c;
    currarr[0] = 1;
    for(int i = 0; i < n; i++){
        clearnext();
        for(int i = 0; i <= c; i++){
            nextarr[0] = (nextarr[0] + currarr[i]) % mod;
        }
        for(int i = 1; i <= c; i++){
            nextarr[i] = currarr[i-1];
        }
        swap(currarr, nextarr);
    }
    long long sum = 0;
    for(int i = 0; i <= c; i++){
        sum = (sum + currarr[i]) % mod;
    }
    out << sum << endl;

    out.close();
    in.close();
}

