/* GCC */
#include <iostream>
#include <fstream>
#include <cstdio>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

typedef unsigned long long ull;

int main()
{
    const int divisor = 1000000007; //10**9+7
    ifstream in;
    ofstream out;
    //in = fopen("A.in", "r");
    in.open("radioactive.in");
    out.open("radioactive.out");
    ull n, c;
    in >> n >> c;
    ull ans_short[c+1];
    ull ans[c+1];
    ans[0] = 1;
    ull ans_i = 1;
    for (ull i = 1; i <= c && i <= n; i++) {
        ans_i = ans_i << 1;
        ans_i = ans_i % divisor;
        ans[i] = ans_i;
        ans_short[i] = ans_i;
    }
    if (n <= c) {
        out << ans[n] << endl;
        return 0;
    }
    for (ull i = c+1; i <= n; i++) {
        ans_i = ans[0]*(ans_short[c]-1);
        ans_i = ans_i % divisor;
        ans_i += ans[c];
        ans_i = ans_i % divisor;
        for (ull j = 0; j < c; j++) {
            ans[j] = ans[j+1];
        }
        ans[c] = ans_i;
    }
    out << ans[c] << endl;
    return 0;
}
