/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>

using namespace std;
#define mod 1000000007
int c, n;
vector<vector<int> > f;

void show(vector<int> a){
    for(int i=0; i<a.size(); i++){
        cout<<a[i]<<' ';
    }
    cout<<endl;
}

void show(vector< vector<int> > a){
    for(int i=0; i<a.size(); i++){
        show(a[i]);
    }
    cout<<endl;
}



void readData(){
    freopen("radioactive.in", "r", stdin);

    scanf("%d%d", &n, &c);
    f=vector< vector<int> >(n+1, vector<int>(c+1));
    f[1][0]=1; f[1][1]=2;
    for(int i=2; i<=c; i++) f[1][i]=2;

    fclose(stdin);
}

void fileOut(){
    freopen("radioactive.out", "w", stdout);

    for(int i=2; i<=n; i++){
        //for 0 -- sum of all prev f[n]
        f[i][0]=f[i-1][c];
        for(int z=1; z<=c; z++){
            //f[i][z]=f[i-1][min(z, i)];
            //f[i][z]=(f[i][z]+f[i][z-1])%mod;
            int prev= z==1 ? f[i-1][z-1] : f[i-1][z-1]-f[i-1][z-2];
            f[i][z]+=(prev+f[i][z-1])%mod;
        }
    }

    printf("%d\n", f[n][c]);
    //show(f);

    fclose(stdin);
}

int main(){
    readData();
    fileOut();
    return 0;
}
