#include <bits/stdc++.h>

#define prt(x) printf(#x" = %lld\n",x)

using namespace std;

typedef long long ll;

const ll N=1e18+10;
const ll C=210;
const ll MOD=1e9+7;

ll ppow(ll x,ll y)
{
    if(y==0)
        return 1;
    if(y&1)
        return (x*ppow(x,y-1))%MOD;
    ll p=ppow(x,y>>1);
    return (p*p)%MOD;
}

ll rev(ll x)
{
    return ppow(x,MOD-2);
}

ll bin(ll n,ll k)
{
    ll res=1;
    for(ll i=1;i<=k;i++)
    {
        res=(res*(n-k+i))%MOD;
        res=(res*rev(i))%MOD;
    }
    return res;
}

ll fact(ll n)
{
    ll res=1;
    for(ll i=2;i<=n;i++)
        res=(res*i)%MOD;
    return res;
}

ll fib(ll n)
{
    ll a=1,b=1;
    for(int i=3;i<=n;i++)
    {
        ll a0=a,b0=b;
        a=b0,b=(a0+b0)%MOD;
    }
    return b;
}

int main()
{
    freopen("radioactive.in","r",stdin);
    freopen("radioactive.out","w",stdout);

    ll n,c;
//    scanf("%lld%lld",&n,&c);
    cin>>n>>c;

//    for(ll n=1;n<=15;n++,printf("\n"))
//        for(ll c=1;c<=15;c++)
//        {
            ll ans;
            ans=ppow(2,n);
            if(c<n)
            {
                ans=(ans-ppow(2,n-c+1)+MOD)%MOD;
                ans=(ans+fib(n-c+3))%MOD;
            }
//            printf("%lld\t",ans);
//        }


//    prt(ppow(2,n));
//    prt(ppow(2,n-c+1));
//    prt(fib(n-c+3));
//    prt(ans);
//    printf("%lld\n",ans);
    cout<<ans;
}
