/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>

using namespace std;
#define mod 1000000007
typedef long long int64;
int64 c, n;
vector<vector<int64> > f;

void show(vector<int64> a){
    for(int64 i=0; i<a.size(); i++){
        cout<<a[i]<<' ';
    }
    cout<<endl;
}

void show(vector< vector<int64> > a){
    for(int64 i=0; i<a.size(); i++){
        show(a[i]);
    }
    cout<<endl;
}



void readData(){
    freopen("radioactive.in", "r", stdin);

    cin>>n>>c;
    f=vector< vector<int64> >(2, vector<int64>(c+1));
    f[1][0]=1; f[1][1]=2;
    for(int64 i=2; i<=c; i++) f[1][i]=2;

    fclose(stdin);
}

void fileOut(){
    freopen("radioactive.out", "w", stdout);

    int CURR=0, PREV=1;
    for(int64 i=2; i<=n; i++){
        //for 0 -- sum of all prev f[n]
        f[CURR][0]=f[PREV][c];
        for(int64 z=1; z<=c; z++){
            //f[i][z]=f[i-1][min(z, i)];
            //f[i][z]=(f[i][z]+f[i][z-1])%mod;
            f[CURR][z]=0;
            int64 prevNum= (z==1) ? f[PREV][z-1] : f[PREV][z-1]-f[PREV][z-2];
            f[CURR][z]+=(prevNum+f[CURR][z-1])%mod;
        }
        swap(CURR, PREV);
        //show(f);
    }

    cout<<f[PREV][c]<<endl;
    //show(f);

    fclose(stdin);
}

int main(){
    readData();
    fileOut();
    return 0;
}
