/* GCC */
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include <set>
#include <cstdio>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
#define MOD 1000000007

bool prime(ll n) {
    for(ll i = 2; i * i <= n; i++) {
        if(n % i == 0) {
            return false;
        }
    }
    return true;
}

ll gcd(ll a, ll b) {
    while(a > 1 && b > 1) {
        if(a > b) {
            swap(a, b);
        }
        b = b % a;
    }
    return max(a, b);
}
struct point {
ll x1, y1, x2, y2;
};

bool per(ll x1, ll y1, ll x2, ll y2, ll xx1, ll yy1, ll xx2, ll yy2) {
    if(x2 >= xx1 && y2 >= yy1)
        return true;
    else return false;
}

int main() {
    freopen("radioactive.in", "r", stdin);
    freopen("radioactive.out", "w", stdout);
    ll n, c, ans = 1;
    cin >> n >> c;
    if(c == 1) {
        ll dp[4];
        ll sum = 0;

        dp[0] = 0, dp[1] = 1, dp[2] = 0;
        for(ll i = 2; i <= n; i++) {
            dp[0] %= MOD, dp[1] %= MOD, dp[2] %= MOD;
            dp[0] = dp[1];
            dp[1] = dp[2];
            dp[1] = sum  + 1;
            sum += dp[0];
            sum %= MOD;
            ans += dp[1];
            ans %= MOD;
        }
    } else if(n < c) {
        ll dp[n];
        ll sum = 1;
        dp[0] = 0; dp[1] = 1;

        for(ll i = 2; i <= n; i++) {
            dp[i] = sum + 1;
            sum += dp[i];
            sum %= MOD;
            ans += dp[i];
            ans %= MOD;
        }
    }

    //for(int i = 0; i <= n; i++) cout << dp[i] << ' '; cout << endl;

    cout << (ans+1)%MOD << endl;
}

/*
3 4
4
1 1 1 2
1 1 3 3
2 2 3 3
2 3 3 4
*/

