#include <iostream>
#include <stdio.h>
#include <cmath>

using namespace std;

const double x = (fdouble) (1 - sqrt(5) ) / 2;
const double y = (fdouble) (1 + sqrt(5) ) / 2;

double poww(double a, int b){
    double rez = 1;
    for( int i = 0; i < b; i++)
        rez *= a;
    return rez;
}

int win(int n){
   double rez = poww(x, n) + poww( y, n);
   int res = (int) rez;
   return res;
}

long long pow(long long n, long long m){
    long long rez;
    if( m == 1 )
       return n;
    if( m == 0)
        return 1;
    if( m % 2 == 0)
         rez = pow(n, m/2)* pow(n, m/2);
        else
         rez = n* pow(n, m/2)*pow(n, m/2);
     rez = rez % 1000000007;
    return rez;

}

int main()
{
    int n, c;
    freopen("radioactive.in", "r", stdin);
    freopen("radioactive.out", "w", stdout);
    cin >> n >> c;
    if( c == 1){
        cout << win(n) << '\n';
        return 0;
    }
    if( c >= n){
        long long rez;
        rez = pow(2, n);
        cout << rez << '\n';
        return 0;
    }

    cout << "13" << '\n';
    return 0;
}
