/* GCC */
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include <set>
#include <cstdio>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

bool prime(ll n) {
    for(ll i = 2; i * i <= n; i++) {
        if(n % i == 0) {
            return false;
        }
    }
    return true;
}

ll gcd(ll a, ll b) {
    while(a > 1 && b > 1) {
        if(a > b) {
            swap(a, b);
        }
        b = b % a;
    }
    return max(a, b);
}

int main() {
    freopen("equation.in", "r", stdin);
    freopen("equation.out", "w", stdout);
    ll a, b, c;

    cin >> a >> b >> c;
    if((a + b) == c) cout << a << '+' << b << '=' << c << endl;
    else if((a - b) == c) cout << a << '-' << b << '=' << c << endl;
    else if((a * b) == c) cout << a << '*' << b << '=' << c << endl;
    else if((a % b == 0) && ((a / b) == c)) cout << a << '/' << b << '=' << c << endl;
    else if((b * c) == a) cout << a << '=' << b << '*' << c << endl;
    else if((b + c) == a) cout << a << '=' << b << '+' << c << endl;
    else if((b - c) == a) cout << a << '=' << b << '-' << c << endl;
    else if((b % c == 0) && ((b / c) == a)) cout << a << '=' << b << '/' << c << endl;

}
