import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;


public class equation {

	public static void main(String[] args) {
		try {
			BufferedReader reader = new BufferedReader(new FileReader("equation.in"));
			BufferedWriter writer = new BufferedWriter(new FileWriter("equation.out"));
			String input = reader.readLine();
			String[] nums = input.split(" ");
			tryEquation(Integer.parseInt(nums[0]), Integer.parseInt(nums[1]), Integer.parseInt(nums[2]), writer);
			writer.close();
			reader.close();
		} catch(Exception e) {
			System.out.println(e);
		}
	}

	static void tryEquation(int num1, int num2, int num3, BufferedWriter output) {
		if(num1 + num2 == num3) {
			printResult(output, num1, num2, num3, false, '+');
		} else if(num1 == num2 + num3) {
			printResult(output, num1, num2, num3, true, '+');
		} else if(num1 - num2 == num3) {
			printResult(output, num1, num2, num3, false, '-');
		} else if(num1 == num2 - num3) {
			printResult(output, num1, num2, num3, true, '-');
		} else if(num1 * num2 == num3) {
			printResult(output, num1, num2, num3, false, '*');
		} else if(num1 == num2 * num3) {
			printResult(output, num1, num2, num3, true, '*');
		} else if(num1 / num2 == num3) {
			printResult(output, num1, num2, num3, false, '/');
		} else if(num1 == num2 / num3) {
			printResult(output, num1, num2, num3, true, '/');
		}
	}
	
	static void printResult(BufferedWriter writer, int num1, int num2, int num3, boolean equalsLeft, char sign) {
		try {
			writer.write(equalsLeft ? (num1 + "=" + num2 + sign + num3) : (num1 + sign + num2 + "=" + num3));
			writer.newLine();
		} catch(Exception e) {
			System.out.println(e);
		}
	}
}
