/* GCC */
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include <set>
#include <cstdio>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

bool prime(ll n) {
    for(ll i = 2; i * i <= n; i++) {
        if(n % i == 0) {
            return false;
        }
    }
    return true;
}

ll gcd(ll a, ll b) {
    while(a > 1 && b > 1) {
        if(a > b) {
            swap(a, b);
        }
        b = b % a;
    }
    return max(a, b);
}

int main() {
    freopen("boxes.in", "r", stdin);
    freopen("boxes.out", "w", stdout);
    ll n, m;
    cin >> n >> m;
    ll a[m];
    for(int i = 0; i < m; i++)
        cin >> a[i];

    sort(a, a + m);

    ll ans = 0, i = 0;
    while((n - a[i]) >= 0) {
        n -= a[i];
        ans++;
        i++;
    }
    cout << ans << endl;
}
