import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;


public class boxes {

	public static void main(String[] args) throws Exception {
		BufferedReader reader = new BufferedReader(new FileReader("boxes.in"));
		FileWriter writer = new FileWriter("boxes.out");
		String[] line1 = reader.readLine().split(" ");
		int boxes = Integer.parseInt(line1[0]);
		int schoolsNum = Integer.parseInt(line1[1]);
		int[] schools = new int[schoolsNum];
		for(int i = 0; i < schoolsNum; i++) {
			String input = reader.readLine();
			schools[i] = Integer.parseInt(input);
		}
		
		for(int i = 0; i < schoolsNum; i++) {
			giveBoxes(i, schools, boxes, 0);
		}
		
		writer.write(Integer.toString(maximumSchools));
		writer.append('\n');
		writer.close();
		reader.close();
	}
	
	static int maximumSchools = 0;
	
	static void giveBoxes(int schoolID, int[] schools, int boxesLeft, int schoolsReceived) {
		boxesLeft -= schools[schoolID];
		
		if(schoolsReceived > maximumSchools)
			maximumSchools = schoolsReceived;
		schools[schoolID] = -1;
		
		for(int i = 0; i < schools.length; i++) {
			if(schools[i] >= 0 && schools[i] <= boxesLeft) {
				giveBoxes(i, schools, boxesLeft, schoolsReceived + 1);
			}
		}
	}
}
