#include <iostream>
#include <cstdlib>
#include <fstream>
#include <string>
#include <vector>

using namespace std;

void sort(int*, int);
int sumUp(int *, int);
int getSchoolsC(int*, int , int);

int main()
{
    fstream fs;
    fs.open("boxes.in", ios::in);
    int n, m;
    fs >> n >> m;
    int *ki = new int[m];
    for(int i = 0; i < m; i++) {
        fs >> ki[i];
    }
    fs.close();

    int num = getSchoolsC(ki, m, n);

    fs.open("boxes.out", ios::out);
    fs << num;
    fs.close();
    delete[] ki;
    return 0;
}

int findMax(int* arr, int n) {
    int max = 0, maxInd;
    for(int i = 0; i < n; i++) {
        if(arr[i] > max) {
            max = arr[i];
            maxInd = i;
        }
    }
    arr[maxInd] = 0;
    return max;
}

int sumUp(int *arr, int n) {
    int sum = 0;
    for(int i = 0; i < n; i++) {
        sum += arr[i];
    }
    return sum;
}

int getSchoolsC(int* arr, int m, int n) {
    sort(arr, m);
    int num = sumUp(arr, m);
    int i = m-1;
    while(num > n) {
        num -= arr[i];
        arr[i--] = 0;
    }

    int schoolsdatget = 0;
    for(int i = 0; i < m; i++) {
        if(arr[i] != 0)
            schoolsdatget++;
    }
    return schoolsdatget;
}

void sort(int *arr, int n) {
    while(1) {
        int tmp;
        bool end;
        for(int i = 0; i < n-1; i++){
            if(arr[i] > arr[i+1]) {
                swap(arr[i], arr[i+1]);
                continue;
            }
            end = true;
        }
        if(end){
            break;
        }
    }
}
