/* GCC */
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include <set>
#include <cstdio>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

bool prime(ll n) {
    for(ll i = 2; i * i <= n; i++) {
        if(n % i == 0) {
            return false;
        }
    }
    return true;
}

ll gcd(ll a, ll b) {
    while(a > 1 && b > 1) {
        if(a > b) {
            swap(a, b);
        }
        b = b % a;
    }
    return max(a, b);
}
struct point {
ll x, y;
};

int main() {
    freopen("magic.in", "r", stdin);
    freopen("magic.out", "w", stdout);
    ll n, m;
    cin >> n;
    n++;

    point a[n];
    ll xx[n], yy[n], curx, cury, miny, maxx;

    for(int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
        xx[i] = a[i].x, yy[i] = a[i].y;
    }

    sort(xx, xx + n);
    sort(yy, yy + n);
    //cout << xx[0] << ' ' << yy[0] << endl;

    for(int i = 0; i < n; i++) {
        curx = a[i].x, cury = a[i].y;

        if(curx == xx[n - 1]) maxx = xx[n - 2];
        else maxx = xx[n - 1];

        if(cury == yy[0]) miny = yy[1];
        else miny = yy[0];
        if(maxx > miny) continue;

        //cout << i << ' ' << curx << ' ' << cury << ' ' << maxx << ' ' << miny << endl;

        if((curx < maxx && cury < maxx) || (curx > miny && cury > miny)) {
           cout << i + 1 << endl;
           return 0;
        }
    }

    cout << 1 << endl;
}
