#include <iostream>
#include <cstdio>
#include <algorithm>

using namespace std;

struct segm
{
    int L, R;
};

segm ar_s[100001];

bool if_cross (int i, int j)
{
    if ( (ar_s[i].L > ar_s[j].R) || (ar_s[i].R < ar_s[j].L) ) return false; /// if do not cross
    return true;
}

int main()
{
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio();
    freopen("magic.in", "r", stdin);
    freopen("magic.out", "w", stdout);
    int N, num_R_left, num_L_right, right_left = 0, left_right = 1e9+1, L, R;

    cin >> N;
    for (int i = 1; i <= N+1; ++i){
        cin >> L >> R;
        ar_s[i] = {L, R};
        if (L > right_left){
            num_R_left = i;
            right_left = L;
        }
        if (R < left_right){
            num_L_right = i;
            left_right = L;
        }
    }
    //cout << num_L_right << " " << num_R_left;

    for (int i = 1; i <= N+1; ++i){
        if ( (if_cross(i, num_R_left) == false) && (i != num_L_right)) {
            cout << num_R_left;
            return 0;
        }
    }
    cout << num_L_right;
    return 0;
}
