/* GCC */

#include <cstdio>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

bool ComDot(int a1, int a2, int b1, int b2){
    if ((a2 < b1) || (b2 < a1)) return false;
    return true;
}

int main(){
    freopen ("magic.in", "r", stdin);
    freopen ("magic.out", "w", stdout);

    int n,k,num;
    vector <pair <int, int> > Edge;

    scanf("%d", &n);
    Edge.resize(n+1);

    for (int i = 0; i<=n; i++){
        scanf("%d%d", &Edge[i].first, &Edge[i].second);
    }

    for (int j = 0; j<n; j++){
        k = 0; num = -1;
        for (int i = j+1; i<=n; i++){
            if (!ComDot(Edge[j].first, Edge[j].second, Edge[i].first, Edge[i].second)){
                k++; num = i;
            }
        }
        if (k > 1){
            printf("%d", j+1);
            return 0;
        }
        if (k == 1){
            printf("%d", num+1);
            return 0;
        }
    }

    printf("%d", n+1);

    return 0;
}
