/* GCC */
#include <iostream>
#include <stdio.h>

using namespace std;

#define MAXN 100100
#define MAXF 100010

int n, control, n_control;
pair<int, int> A[MAXN];
int X[MAXN];
int F[2*MAXF];

int SumSeg(int a, int v, int l, int r)
{
    if ((l == a) && (a == r)) return F[v];
    int m = (l+r)/2;
    if (a > m)
        return SumSeg(a, 2*v+1, m+1, r) + F[v];
    else
        return SumSeg(a, 2*v, l, m) + F[v];
}

void change(int a, int b, int v, int l, int r)
{
    if ((l == a) && (b == r)){
        F[v] += 1;/*
        if (F[v] > n_control){
            n_control = F[v];
            control = l;
        }*/
        return;
    }
    int m = (l+r)/2;
    if (a >  m){ change(a, b, 2*v+1, m+1, r); return; }
    if (m >= b){ change(a, b, 2*v  , l  , m); return; }
    change(a, m, 2*v, l, m);
    change(m+1, b, 2*v+1, m+1, r);
    return;
}

int main(void)
{
    freopen("magic.in", "r", stdin);
//    freopen("magic.out", "w", stdout);

    cin >> n;
    for (int i=1; i<=(n+1); i++){
//        cout << "HI_IN" << endl;
        cin >> A[i].first >> A[i].second;
        change(A[i].first, A[i].second, 1, 1, MAXF);
    }

    for (int i=1; i<=n; i++)
        if (SumSeg(i, 1, 1, MAXF) == n){
            control = i;
            break;
        }

//    cout << "HI" << endl;
    for (int i=1; i<=(n+1); i++)
        if ((control < A[i].first) || (A[i].second < control)){
            cout << i << endl;
            return 0;
        }

    return 0;
}
