/* GCC */
#include <iostream>
#include <stdio.h>

using namespace std;

#define MAXN 100100
#define MAXF 100000010

int n, control, n_control;
pair<int, int> A[MAXN];
int X[MAXN];
int F[2*MAXF];

int SumSeg(int a, int v, int l, int r)
{
    if ((l == a) && (a == r)) return F[v];
    int m = (l+r)/2;
    if (a > m)
        return SumSeg(a, 2*v+1, m+1, r) + F[v];
    else
        return SumSeg(a, 2*v, l, m) + F[v];
}

void change(int a, int b, int v, int l, int r)
{
    if ((l == a) && (b == r)){
        F[v] += 1;/*
        if (F[v] > n_control){
            n_control = F[v];
            control = l;
        }*/
        return;
    }
    int m = (l+r)/2;
    if (a >  m){ change(a, b, 2*v+1, m+1, r); return; }
    if (m >= b){ change(a, b, 2*v  , l  , m); return; }
    change(a, m, 2*v, l, m);
    change(m+1, b, 2*v+1, m+1, r);
    return;
}

pair<int, int> cross(pair<int, int> a, pair<int, int> b)
{
    pair<int, int> res;
    if ((a.second < b.first) || (b.second < a.first)){
        res.first = -1;
        res.second = -1;
        return res;
    }
    if (a.first < b.first)
        res.first = b.first;
    else
        res.first = a.first;
    if (a.second > b.second)
        res.second = b.second;
    else
        res.second = a.second;
    return res;
}

int main(void)
{
    freopen("magic.in", "r", stdin);
//    freopen("magic.out", "w", stdout);

    cin >> n;
    for (int i=1; i<=(n+1); i++){
        cin >> A[i].first >> A[i].second;
    }

    pair<int, int> x = A[1];
    for (int i=2; i<=(n+1); i++){
        x = cross(x, A[i]);
        if (x.first == -1){
            cout << i << endl;
            return 0;
        }
    }

    cout << "1" << endl;
    return 0;
}
