/* GCC */
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include <set>
#include <cstdio>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

bool prime(ll n) {
    for(ll i = 2; i * i <= n; i++) {
        if(n % i == 0) {
            return false;
        }
    }
    return true;
}

ll gcd(ll a, ll b) {
    while(a > 1 && b > 1) {
        if(a > b) {
            swap(a, b);
        }
        b = b % a;
    }
    return max(a, b);
}
struct point {
ll x1, y1, x2, y2;
};

bool per(ll x1, ll y1, ll x2, ll y2, ll xx1, ll yy1, ll xx2, ll yy2) {
    if(y1 < yy1) {
        swap(x1, xx1);
        swap(x2, xx2);
        swap(y1, yy1);
        swap(y2, yy2);
    }
    if(((xx1 >= x1) && (xx1 <= x2) && (yy1 <= y2)) || ((xx2 <= x2) && (xx2 >= x1) && (yy1 <= y2)))
        return true;
    else if(((xx1 <= x1) && (xx2 >= x1) && (yy1 <= y2)) || ((xx1 <= x2) && (xx2 >= x2) && (yy1 <= y2)))
        return true;
    else return false;
}

int main() {
    freopen("football.in", "r", stdin);
    freopen("football.out", "w", stdout);
    ll n, nn, mm, ans = 0;
    cin >> nn >> mm;
    cin >> n;
    point a[n];

    for(int i = 0; i < n; i++)
        cin >> a[i].x1 >> a[i].y1 >> a[i].x2 >> a[i].y2;

    for(int i = 0; i < n; i++) {
        for(int j = i + 1; j < n; j++) {
            if(per(a[i].x1, a[i].y1, a[i].x2, a[i].y2, a[j].x1, a[j].y1, a[j].x2, a[j].y2))
                ans++;
        }
    }
    cout << ans << endl;
}

/*
3 4
4
1 1 1 2
1 1 3 3
2 2 3 3
2 3 3 4
*/

