import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;

public class football {

	public static void main(String[] args) throws Exception {
		BufferedReader reader = new BufferedReader(new FileReader("football.in"));
		FileWriter writer = new FileWriter("football.out");
		
		String input = reader.readLine();
		int goodPairs = 0;
		int playersTotal = Integer.parseInt(reader.readLine());
		int[][] players = new int[playersTotal][4]; //xStart, yStart, xEnd, yEnd
		for(int i = 0; i < playersTotal; i++) {
			String[] coords = reader.readLine().split(" ");
			int xStart = Integer.parseInt(coords[0]);
			int yStart = Integer.parseInt(coords[1]);
			int xEnd = Integer.parseInt(coords[2]);
			int yEnd = Integer.parseInt(coords[3]);
			players[i][0] = xStart;
			players[i][1] = yStart;
			players[i][2] = xEnd;
			players[i][3] = yEnd;
			for(int i2 = 0; i2 < i; i2++) {
				int[] player2 = players[i2];
				if(xStart <= player2[2] && xEnd >= player2[0] && yStart <= player2[3] && yEnd >= player2[1])
					goodPairs++;
			}
		}
		
		writer.write(Integer.toString(goodPairs));
		writer.append(System.lineSeparator());
		
		writer.close();
		reader.close();
	}
}
