#include <iostream>
#include <cstdio>

using namespace std;

struct prymoug
{
    int x1, y1, x2, y2;
};

prymoug rects[5001];

bool if_cross (int a, int b)
{
    prymoug fir = rects[a], sec = rects[b];
    if ( ((sec.x1 > fir.x2) || (sec.x2 < fir.x1)) || ((sec.y1 > fir.y2) || (sec.y2 < fir.y1)) )
        return false;
    return true;
}

int main()
{
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio();
    freopen("football.in", "r", stdin);
    freopen("football.out", "w", stdout);
    int N, M, Q, x1, y1, x2, y2, res = 0;
    cin >> N >> M >> Q;
    if (Q <= 5000){
        for (int i = 0; i < Q; ++i){
            cin >> x1 >> y1 >> x2 >> y2;
            rects[i] = {x1, y1, x2, y2};
        }
        for (int a = 0; a < Q; ++a){
            for (int b = a+1; b < Q; ++b){
                if (if_cross(a, b)) ++res;
            }
        }
        cout << res;
    }
    else{
        cout << "100";
    }
    return 0;
}
