program football;

{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  TPoint = record
    x, y: word;
  end;

  TRect = record
    upLeft: TPoint;
    downRight: TPoint;
  end;

  tarr = array [1..1000000] of TRect;

procedure swap(var a1, a2: TRect);
var
  temp: TRect;
begin

  temp:=a1;
  a1:=a2;
  a2:=temp;

end;

function equals(a1, a2: TPoint):boolean;
begin

  if (a1.x=a2.x) and (a1.y=a2.y) then
    equals:=true
  else
    equals:=false;

end;

procedure lineSort(var mas: tarr; l, r: longint);
var
  i, j: longint;
  k: TRect;

begin

  i:=l; j:=r;
  k:=mas[(l+r) div 2];

  while (i<j) do
  begin

    while (mas[i].upLeft.x<k.upLeft.x) or ((mas[i].upLeft.x=k.upLeft.x) and (mas[i].upLeft.y<k.upLeft.y)) do
      inc(i);

    while (mas[j].upLeft.x>k.upLeft.x) or ((mas[j].upLeft.x=k.upLeft.x) and (mas[j].upLeft.y>k.upLeft.y)) do
      dec(j);

    if (i<=j) then
    begin

      swap(mas[i], mas[j]);
      inc(i);
      dec(j);

    end;

  end;

  if (l<j) then linesort(mas, l, j);
  if (i<r) then linesort(mas, i, r);

end;

function checkInLine(rect1, rect2: TRect):boolean;
var
  point11, point21: TPoint;
  point12, point22: TPoint;
begin

  point11.x:=rect1.downRight.x;
  point11.y:=rect1.upLeft.y;
  point12:=rect1.downRight;

  point21:=rect2.upLeft;
  point22.x:=rect2.upLeft.x;
  point22.y:=rect2.downRight.y;

  if (point21.x<=point11.x) and (point21.y>=point11.y) and (point12.y>=point21.y) then
    checkInLine:=true
  else if (point22.x<=point11.x) and (point22.y>=point11.y) and (point22.y<=point12.y) then
    checkInLine:=true
  else
    checkInLine:=false;
    
end;

var
  mas: tarr;
  n, m, q: longint;
  i, j: longint;
  count: int64;
  f1, f2: text;
begin

  assign(f1, 'football.in');
  assign(f2, 'football.out');
  reset(f1);
  rewrite(f2);

  read(f1, n, m, q);

  for i:=1 to q do
    read(f1, mas[i].upLeft.x, mas[i].upLeft.y,
              mas[i].downRight.x, mas[i].downRight.y);

  count:=0;

  linesort(mas, 1, q);

  for i:=1 to q do
  begin

    j:=i+1;

    while (j<q+1) and (mas[j].upLeft.x<=mas[i].downRight.x) do
    begin

      if (checkInLine(mas[i], mas[j])) then
        inc(count);
      inc(j);

    end;

  end;

  writeln(f2, count);
  
  close(f1);
  close(f2);

end.
