/* GCC */

#include<fstream>

using namespace std;

struct square{
    square(){}
    int x1, y1, x2, y2;
};

int n, m, q;
square arr[1000000];

bool hasPoint(square s1, square s2){
    return s1.x1 <= s2.x2 && s1.y1 <= s2.y2 && s1.x2 >= s2.x1 && s1.y2 >= s2.y1;
}

int main(){
    ifstream in;
    in.open("football.in");
    ofstream out;
    out.open("football.out");

    in >> n >> m >> q;
    for(int i = 0; i < q; i++){
        int a, b, c, d;
        in >> a >> b >> c >> d;
        arr[i].x1 = a;
        arr[i].y1 = b;
        arr[i].x2 = c;
        arr[i].y2 = d;
    }
    long long sum = 0;
    for(int i = 0; i < q; i++){
        for(int j = 0; j < i; j++){
            sum += hasPoint(arr[i], arr[j]) ? 1 : 0;
        }
    }
    out << sum << endl;

    out.close();
    in.close();
}

