/* GCC */
#include <iostream>
#include <fstream>
#include <cstdio>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

bool intersect (int x1ul, int y1ul, int x1lr, int y1lr, int x2ul, int y2ul, int x2lr, int y2lr) {
    bool is_x = false, is_y = false;
    if (max(x1ul, x2ul) <= min(x1lr, x2lr)) {
        is_x = true;
    }
    if (max(y1ul, y2ul) <= min(y1lr, y2lr)) {
        is_y = true;
    }
    return (is_x && is_y);
}

typedef unsigned long long ull;

int main()
{
    ifstream in;
    ofstream out;
    //in = fopen("A.in", "r");
    in.open("football.in");
    out.open("football.out");

    int n, m, q;
    in >> n >> m >> q;

    int xul[q];
    int yul[q];
    int xlr[q];
    int ylr[q];

    ull ans = 0;

    for (int i = 0; i < q; i++) {
        in >> xul[i] >> yul[i] >> xlr[i] >> ylr[i];
        for (int j = 0; j < i; j++) {
            if (intersect(xul[i], yul[i],
                          xlr[i], ylr[i],
                          xul[j], yul[j],
                          xlr[j], ylr[j])) {
                ans++;
            }
        }
    }

    out << ans << endl;

    return 0;
}
