/* GCC */
#include <iostream>
#include <fstream>

using namespace std;

typedef struct {
    int x1, y1;
    int x2, y2;
} Rectangle;

bool check(const Rectangle &a, const Rectangle &b) {
   int side_a_x = a.x2 - a.x1;
   int side_a_y = a.y2 - a.y1;
//   int side_b_y = b.y2 - b.y1;
//   int side_b_x = b.x2 - b.x1;
   int ax3 = a.x1;
   int ay3 = a.y2;
   int ax4 = a.x2;
   int ay4 = a.y1;
   if ((ay3 >= b.y1) && (ay3 <= b.y2) && (ax3 >= b.x1) && (ax3 <= b.x2)) return true;
   if ((ay4 >= b.y1) && (ay4 <= b.y2) && (ax4 >= b.x1) && (ax4 <= b.x2)) return true;
   if ((a.y2 >= b.y1) && (a.y2 <= b.y2) && (a.x2 >= b.x1) && (a.x2 <= b.x2)) return true;
   if ((a.y1 >= b.y1) && (a.y1 <= b.y2) && (a.x1 >= b.x1) && (a.x1 <= b.x2)) return true;
   return false;
}
int main()
{
    ifstream fin ("football.in");
    ofstream fout ("football.out");
    int n,m,q;
    fin >> n >> m >> q;
    Rectangle rect[q];
    for (int i = 0; i < q; i++) {
        fin >> rect[i].x1 >> rect[i].y1 >> rect[i].x2 >> rect[i].y2;
    }
    int count = 0;
    for (int i = 0; i < q; i++) {
        for (int j = i+1; j < q; j++) {
            if (check(rect[i], rect[j])) {
                count++;
                //cout << i+1 << " and " << j+1 << endl;
            }
        }
    }
    fout << count;
    return 0;
}
