#include <iostream>
#include <fstream>
#include <cstdlib>


using namespace std;

struct Point {
    int x = 0;
    int y = 0;
    Point() {}
    Point(int x, int y) :x(x), y(y) {}
};

struct Rect {
    Point left;
    Point right;

    Rect() {}
    Rect(Point left, Point right) : left(left), right(right) {}
};
int main()
{
    fstream fs;
    fs.open("football.in", ios::in);
    int rows, cols, playas;
    fs >> rows >> cols;
    fs >> playas;
    Rect arr[playas];
    for(int i = 0; i < playas; i++) {
        fs >> arr[i].left.x;
        fs >> arr[i].left.y;
        fs >> arr[i].right.x;
        fs >> arr[i].right.y;
    }

    fs.close();
    int cnt;

    for(int i = 0; i < playas; i++) {
        for(int j = 0; j < playas; j++) {
            if(i==j)
                continue;
            if((!((arr[j].left.x > arr[i].right.x) || (arr[j].left.x > arr[i].right.y))) && ((arr[j].left.x > arr[i].left.x) || (arr[j].left.y > arr[i].left.y)))
                cnt++;
            if((!((arr[i].left.x > arr[j].right.x) || (arr[i].left.x > arr[j].right.y))) && ((arr[i].left.x > arr[j].left.x) || (arr[i].left.y > arr[j].left.y)))
                cnt++;
        }
    }

    fs.open("football.out", ios::out | ios::trunc);
    fs << cnt;
    cout << cnt;
    fs.close();
    return 0;
}
