#include <bits/stdc++.h>

#define prt(x) printf(#x" = %lld\n",x)

using namespace std;

typedef long long ll;

const ll N=1e18+10;
const ll C=210;
const ll MOD=1e9+7;

ll ppow(ll x,ll y)
{
    if(y==0)
        return 1;
    if(y&1)
        return (x*ppow(x,y-1))%MOD;
    ll p=ppow(x,y>>1);
    return (p*p)%MOD;
}

ll rev(ll x)
{
    return ppow(x,MOD-2);
}

ll bin(ll n,ll k)
{
    ll res=1;
    for(ll i=1;i<=k;i++)
    {
        res=(res*(n-k+i))%MOD;
        res=(res*rev(i))%MOD;
    }
    return res;
}

ll fact(ll n)
{
    ll res=1;
    for(ll i=2;i<=n;i++)
        res=(res*i)%MOD;
    return res;
}

ll fib(ll n)
{
    ll a=1,b=1;
    for(ll i=3;i<=n;i++)
    {
        ll a0=a,b0=b;
        a=b0,b=(a0+b0)%MOD;
    }
    return b;
}

int main()
{
    freopen("radioactive.in","r",stdin);
    freopen("radioactive.out","w",stdout);

    ll n,c;
    scanf("%lld%lld",&n,&c);
    if(n<=c)
        printf("%lld\n",ppow(2,n)),exit(0);
    if(c==1)
        printf("%lld\n",fib(n+2)),exit(0);
//    ll dp[n+1][c+1];
    vector< ll , vector<ll>(c+1) >(n+1);
    dp[0][0]=1;
    for(ll i=1;i<=c;i++)
        dp[0][i]=0;
    for(ll i=1;i<=n;i++)
    {
        dp[i][0]=0;
        for(ll j=0;j<=c;j++)
            dp[i][0]+=dp[i-1][j];
        //printf("%lld\t",dp[i][0]);
        for(ll j=1;j<=c;j++)
            dp[i][j]=dp[i-1][j-1]/*,printf("%lld\t",dp[i][j])*/;
        //printf("\n");
    }
    ll ans=0;
    for(int i=0;i<=c;i++)
        ans+=dp[n][i];
    printf("%lld\n",ans);
}
